import pygame
from random import randint

pygame.init()

W = 800
H = 400
vindu = pygame.display.set_mode((W, H))
pygame.display.set_caption("Bilder")

clock = pygame.time.Clock()
FPS = 30

# Bilder
fisk = pygame.image.load("assets/fish.png")
fisk_rect = fisk.get_rect()
fisk_rect.center = (W//2, H//2)

fisk_hoyre = pygame.transform.flip(fisk, flip_x=True, flip_y=False)

reke = pygame.image.load("assets/reke.png")
reke = pygame.transform.scale_by(reke, 0.7)
reke = pygame.transform.flip(reke, flip_x=True, flip_y=False)
reke_rect = reke.get_rect()
reke_rect.center = (100, H//2)

# La den plasseres tilfeldig
reke_x = randint(reke_rect.width, W - reke_rect.width)
reke_y = randint(reke_rect.height + 50, H - reke_rect.height - 50)
reke_rect.center = (reke_x, reke_y)

# Tekst - kan bruke .otf eller .ttf
font = pygame.font.Font("assets/coolvetica.otf", 32)
tekst = font.render("Fiskespillet", True, "black")
tekst_rect = tekst.get_rect()
tekst_rect.center = (W//2, 20)

font2 = pygame.font.Font("assets/coolvetica.otf", 16)
tekst2 = font2.render("Bruk piltastene for å styre fisken. Spis så mange reker du kan!", True, "black")
tekst2_rect = tekst2.get_rect()
tekst2_rect.center = (W//2, H - 15)

# Lyd og musikk
pygame.mixer.music.load("assets/under_water.wav")
eat_sound = pygame.mixer.Sound("assets/eat.wav")

# Hovedløkke
running = True
game_over = False
fisken = fisk
pygame.mixer.music.play(-1)
while running:
    # Sjekk om bruker prøver å avslutte
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            running = False

    taster = pygame.key.get_pressed()
    # print(taster)
    if taster[pygame.K_LEFT] and fisk_rect.left > 10:
        fisk_rect.x -= 8
        fisken = fisk
    if taster[pygame.K_RIGHT] and fisk_rect.right < W - 10:
        fisk_rect.x += 8
        fisken = fisk_hoyre
    if taster[pygame.K_UP] and fisk_rect.top > 50:
        fisk_rect.y -= 8
    if taster[pygame.K_DOWN] and fisk_rect.bottom < H - 20:
        fisk_rect.y += 8

    vindu.fill("lightblue")
    # Vis bilder
    vindu.blit(fisken, fisk_rect)
    vindu.blit(reke, reke_rect)

    # Kolliderer fisken med reka?
    if fisk_rect.colliderect(reke_rect):
        # print("kollisjon")
        eat_sound.play()
        # Flytt bort reka
        reke_x = randint(reke_rect.width, W - reke_rect.width)
        reke_y = randint(reke_rect.height + 50, H - reke_rect.height - 50)
        reke_rect.center = (reke_x, reke_y)
        # Legg til poeng
        poeng += 1
        font3 = pygame.font.Font("assets/coolvetica.otf", 20)
        tekst3 = font3.render(f"Poeng: {poeng}", True, "black")
        tekst3_rect = tekst3.get_rect()
        tekst3_rect.center = (100, 20)
    # Vis tekst
    vindu.blit(tekst, tekst_rect)
    vindu.blit(tekst2, tekst2_rect)
    vindu.blit(tekst3, tekst3_rect)
    if poeng >= 20:
        tekst4 = font3.render("Du har vunnet", True, "black")
        tekst4_rect = tekst4.get_rect()
        tekst4_rect.center = (W - tekst4_rect.width - 20, 20)
        vindu.blit(tekst4, tekst4_rect)
        reke_rect.left = -100
        game_over = True

    # Linjer over og under
    pygame.draw.line(vindu, "black", (0, 45), (W, 45), 3)
    pygame.draw.line(vindu, "black", (0, H - 25), (W, H - 25), 3)

    pygame.display.flip()
    if game_over:
        pygame.time.wait(1500)
        running = False
    clock.tick(FPS)

pygame.quit()